<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class BotModelMetadata extends \Google\Protobuf\Internal\Message
{
    


    protected $modelType = null;
    


    protected $premiumModelStatus = null;
    


    protected $modelNameOverride = null;

    










    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getModelType()
    {
        return isset($this->modelType) ? $this->modelType : 0;
    }

    public function hasModelType()
    {
        return isset($this->modelType);
    }

    public function clearModelType()
    {
        unset($this->modelType);
    }

    




    public function setModelType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotModelMetadata\ModelType::class);
        $this->modelType = $var;

        return $this;
    }

    



    public function getPremiumModelStatus()
    {
        return isset($this->premiumModelStatus) ? $this->premiumModelStatus : 0;
    }

    public function hasPremiumModelStatus()
    {
        return isset($this->premiumModelStatus);
    }

    public function clearPremiumModelStatus()
    {
        unset($this->premiumModelStatus);
    }

    




    public function setPremiumModelStatus($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotModelMetadata\PremiumModelStatus::class);
        $this->premiumModelStatus = $var;

        return $this;
    }

    



    public function getModelNameOverride()
    {
        return isset($this->modelNameOverride) ? $this->modelNameOverride : '';
    }

    public function hasModelNameOverride()
    {
        return isset($this->modelNameOverride);
    }

    public function clearModelNameOverride()
    {
        unset($this->modelNameOverride);
    }

    




    public function setModelNameOverride($var)
    {
        GPBUtil::checkString($var, True);
        $this->modelNameOverride = $var;

        return $this;
    }

}

